package com.steerinfo.dil.controller;

import com.alibaba.fastjson.JSON;
import com.steerinfo.dil.feign.ColumnDataFeign;
import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.model.TmstrainWagonUnloadResult;
import com.steerinfo.dil.service.ITmstrainWagonUnloadResultService;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstrainWagonUnloadResult RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 09:22
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmstrainWagonUnloadResult RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/tmstrainwagonunloadresults")
public class TmstrainWagonUnloadResultController extends BaseRESTfulController {

    @Autowired
    ITmstrainWagonUnloadResultService tmstrainWagonUnloadResultService;

    @Autowired
    ColumnDataFeign columnDataFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @Autowired
    ESFeign esFeign;

    @ApiOperation(value = "查询卸车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(60)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTmstrainWagonUnLoad")
    public RESTfulResult getTmstrainWagonUnLoad(@RequestBody(required = false) Map<String, Object> mapValue,
                                                Integer apiId,
                                                Integer pageNum,
                                                Integer pageSize,
                                                Integer resultType,
                                                String con) {
        if(resultType!= null)
            mapValue.put("resultType", resultType);
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainWagonUnLoad = tmstrainWagonUnloadResultService.getTmstrainWagonUnLoad(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null, tmstrainWagonUnLoad);
        return success(pageList);
    }

    /**
     * 通过主键删除车皮卸车作业实绩
     *
     * @param unloadingId
     * @return
     */
    @ApiOperation(value = "通过主键删除车皮卸车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "unloadingId", value = "主键ID", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/deleteTmstrainWagonUnLoadResultByUnLoadingId")
    public RESTfulResult deleteTmstrainWagonUnLoadResultByUnLoadingId(@RequestParam BigDecimal unloadingId) {
        int i = tmstrainWagonUnloadResultService.deleteTmstrainWagonUnLoadResultByUnLoadingId(unloadingId);
        return success(i);
    }

    /**
     * 新增车皮卸车作业实绩
     *
     * @param tmstrainWagonUnloadResult
     * @return
     */
    @ApiOperation(value = "新增车皮卸车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainWagonUnloadResult", value = "车皮卸车对象", required = false, dataType = "TmstrainWagonUnloadResult")
    })
    @PostMapping(value = "/insertTmstrainWagonUnLoadResult")
    public RESTfulResult insertTmstrainWagonUnLoadResult(@RequestBody(required = false) TmstrainWagonUnloadResult tmstrainWagonUnloadResult, Integer orderType) {
        int i = tmstrainWagonUnloadResultService.insertTmstrainWagonUnLoadResult(tmstrainWagonUnloadResult);
        return success(i);
    }

    /**
     * 通过主键修改车皮卸车作业实绩
     *
     * @param tmstrainWagonUnloadResult
     * @return
     */
    @ApiOperation(value = "通过主键修改车皮卸车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainWagonUnloadResult", value = "车皮卸车对象", required = false, dataType = "TmstrainWagonUnloadResult")
    })
    @PostMapping(value = "/upadteTmstrainWagonUnLoadResultByUnLoadingId")
    public RESTfulResult upadteTmstrainWagonUnLoadResultByUnLoadingId(@RequestBody(required = false) TmstrainWagonUnloadResult tmstrainWagonUnloadResult) {
        System.out.println(tmstrainWagonUnloadResult);
        int i = tmstrainWagonUnloadResultService.updateTmstrainWagonUnLoadResult(tmstrainWagonUnloadResult);
        return success(i);
    }

    @ApiOperation(value = "查看火运实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(65)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTmstrainresult")
    public RESTfulResult getTmstrainresult(@RequestBody(required = false) Map<String, Object> mapValue,
                                           Integer apiId,
                                           Integer pageNum,
                                           Integer pageSize,
                                           String con) {

        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainResult1 = tmstrainWagonUnloadResultService.getTmstrainResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null, tmstrainResult1);
        return success(pageList);
    }

    /**
     * 获取卸车地点名称
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取卸车地点名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getUnloadingPointName")
    public RESTfulResult getUnloadingPointName() {

        return success(tmstrainWagonUnloadResultService.getUnloadingPointName());
    }

    /**
     * 获取卸车路径名称
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取卸车路径名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getUnloadingRouteName")
    public RESTfulResult getUnloadingRouteName() {
        return success(tmstrainWagonUnloadResultService.getUnloadingRouteName());
    }

    /**
     * 通过主键查询车皮卸车作业信息
     *
     * @param unloadingId
     * @return
     */
    @ApiOperation(value = "通过主键查询车皮卸车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "unloadingId", value = "车皮卸车主键", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/getTmstrainWagonUnLoadResultByUnLoadingId/{unloadingId}")
    public RESTfulResult getTmstrainWagonUnLoadResultByUnLoadingId(@PathVariable("unloadingId") BigDecimal unloadingId, Integer orderType) {
        List<Map<String, Object>> mes = tmstrainWagonUnloadResultService.getTmstrainWagonUnLoadResultByUnLoadingId(unloadingId);
        return success(mes);
    }

    //********内转实绩**************************************
    @ApiOperation(value = "内转新增卸车实绩")
    @ApiImplicitParams({
    })
    @PostMapping(value = "/addTmsTrainUnloadResultForNZ")
    public RESTfulResult addTmsTrainUnloadResultForNZ(@RequestBody(required = false)Map<String, Object> map) {
        int i = tmstrainWagonUnloadResultService.addTmsTrainUnloadResultForNZ(map);
        return success(i);
    }


    //*********内转物流查询火车卸车实绩************************************
    @ApiOperation(value = "查询火车卸车信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(202)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/selectTrainUnLoadResultForConverted")
    public RESTfulResult selectTrainUnLoadResultForConverted(@RequestBody(required = false) Map<String, Object> mapValue,
                                                             Integer apiId,
                                                             Integer pageNum,
                                                             Integer pageSize,
                                                             String con) {

        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainWagonUnLoad1 = tmstrainWagonUnloadResultService.getTmstrainResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null, tmstrainWagonUnLoad1);
        return success(pageList);
    }


}
