package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstrainLoadingResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstrainLoadingResultMapper extends IBaseMapper<TmstrainLoadingResult, BigDecimal> {
    //查询装车作业信息
    List<Map<String, Object>> getTmsWagonLoadInfo(Map<String,Object> map);

    //查询主键最大值
    @Select("select seq_tmstrian_loading.nextval from dual")
    BigDecimal selectMaxId();
    //获取外轮船名
    String getResultForeignShipName(BigDecimal batchId);
    //获取物资ID
    BigDecimal getMaterialID(BigDecimal batchId);
    //获得采购订单id
    BigDecimal getPurchaseOrderId(BigDecimal batchId);
    //获得发站地点名称
    List<Map<String, Object>> getSendStationName();
    //获得到站地点名称
    List<Map<String, Object>> getArrivalStationName();
    //获得批次ID
    List<Map<String, Object>> getBatchId();
    //获得装车车皮号
    List<Map<String, Object>> getWagonNo(Map<String, Object> map);
    //获得要渲染的数据
    List<Map<String, Object>> selectByResultId(BigDecimal ResultId);
    //通过发站ID查询所属港口ID
    BigDecimal getPortIdBySendStationId(BigDecimal sendStationId);
    //通过发运计划号查找物资信息
    Map<String,Object> getMaterialInfoByRailPlanId(Integer railPlanId);
    //内转物流查询装车实绩并展示
    List<Map<String,Object>> selectLoadedForConverted(Map<String,Object> map);
    //内转物流通过id查询装车作业
    List<Map<String,Object>> selectLoadByResultId(BigDecimal resultId);
    //通过车皮号与发运计划ID查询火车装车实绩ID
    Integer getLoadingIdByWnoAndRailPlanId(@Param("resultWagonNo")String resultWagonNo, @Param("railPlanId")Integer railPlanId);

    //拿到扫描结果匹配扫描出库中出库主键ID
    Integer getOutBoundResultIdByScan(@Param("scanText") String scanText);

    //通过出库主键ID查询订单总实绩ID
    Map<String, Object> getResultTotalIdByOutBoundResultId(Integer outboundResultId);

    //通过装车实绩主键查询关联的物资信息与车牌号
    List<Map<String, Object>> getMaterialAndCarByLoadingId(Map<String, Object> map);

    //通过汽运总实绩ID查询装车中间表
    Integer getTrainTruckIdByTruckTotalId(BigDecimal resultTotalId);

    //通过采购订单Id查询批次Id
    BigDecimal getBatchIdByPurOrderId(BigDecimal purchaseOrderId);

    //通过采购订单Id查询批次、物资id、承运商id等补录信息
    Map<String, Object> getRecordByPurOrderId(BigDecimal purchaseOrderId);

    //查询没有采购订单号的装车实绩
    List<Map<String, Object>> getNoPurOrderIdLoadResult(Map<String, Object> map);

    //根据发站名查发站id
    BigDecimal getSendStationId(String sendStationName);

    //获取最大发站id
    BigDecimal getMaxSendStationId();

    //添加发站
    Integer addSendStation(Map<String,Object> map);

    //根据物资名或订单号和外轮船名查询采购订单号
    List<Map<String,Object>> getPurchaseOrderList(Map<String,Object> map);
}