package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstrainWagonUnloadResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface    TmstrainWagonUnloadResultMapper extends IBaseMapper<TmstrainWagonUnloadResult, BigDecimal> {
    //查询采购卸车作业信息
    List<Map<String, Object>> getTmsWagonUnLoadInfo(Map<String,Object>map);
    //查询主键最大值
    @Select("select seq_tmstrian_wagon_unload.nextval from dual")
    BigDecimal selectMaxId();
    //获得采购订单id
    BigDecimal getUnloadId(Map<String, Object> map);
    //查询火运实绩
    List<Map<String, Object>> getTmstrainResult(Map<String,Object>map);
    //获得卸车地点名称
    List<Map<String, Object>> getUnloadingPointName();
    //获得卸车路线名称
    List<Map<String, Object>> getUnloadingRouteName();
    //获得要渲染的数据
    List<Map<String, Object>> selectByUnLoadingId(BigDecimal unloadingId);

    //内转物流查询卸车实绩
    List<Map<String,Object>> selectWagonUnLoadResultForNZ(Map<String,Object> map);

    //内转物流查询火车卸货实绩
    List<Map<String,Object>> getTrainResult(Map<String,Object> map);

    //内转达州站到厂内料场
    List<Map<String, Object>> getTrainUnloadDaZhouToDaGang(Map<String, Object> map);

    //内转老区轨道衡-厂内料场
    List<Map<String, Object>> getTrainUnloadLaoQuToDaGgang(Map<String, Object> map);
    /**
     * txf
     */
    //通过运输订单ID查询当前订单关联的装车实绩ID
    List<Map<String, Object>> getTotalIdByOrderId(BigDecimal orderId);

    //通过火运总实绩ID查询火运装车实绩ID
    Integer getLoadingIdByTrainTotalId(BigDecimal trainTotalId);

    //通过装车实绩ID查询车皮号与发运计划ID
    Map<String, Object> getWagonNoAndRailPlanByLoadingId(Integer loadingId);

    //通过车皮号与发运计划ID匹配卸车实绩
    Integer getUnloadIdByWagonNoAndRailPlanId(@Param("resultWagonNo") String resultWagonNo, @Param("railPlanId") BigDecimal railPlanId);
}